# Python source code generated by SCC (StateChart Compiler) 0.1, written by Thomas Feng
#   Source: SSGridViewStateChart.des
#   Date:   March 29, 2004
#   Time:   1:34:50


# Header Section -- definition and module importation used by the following parts
import sys
import copy
import time
import string


class State:

  def __init__(self):

    self.StateID=-1
    self.Next=None


class History:

  def __init__(self):

    self.States=None
    self.Times=None
    self.Submodel=None


class EventList:

  def __init__(self):

    self.Event=None
    self.Next=None

  def Append(self, e):

    if isinstance(e, str):
      el=EventList()
      el.Event=e
      cur=this
      while cur.Next!=None and cur.Event!=e:
        cur=cur.Next;
      if cur.Event!=e:
        cur.Next=el

    elif isinstance(e, EventList):
      el=e
      while el!=None:
        self.Append(el.Event)
        el=el.Next


class StringList:

  def __init__(self, str=""):

    self.str=str
    self.Next=None


class IntList:

  def __init__(self, int=0):

    self.int=int
    self.Next=None


class Hierarchy:

  def __init__(self):

    self.StateName=None
    self.PathName=None
    self.StateNum=-1
    self.Level=-1
    self.Next=None


# Scheduler for timed transitions (used only when --ext is set)
import thread
import time
class Scheduler:

  def __init__(self, model, event, interval, repeat):

    self.Model=model
    self.Event=event
    self.Interval=interval
    self.Repeat=repeat
    self.Lock=thread.allocate_lock()
    self.Stopped=0
    self.Next=None

  def start(self):

    thread.start_new_thread(self.run, ())

  def stop(self):

    self.Lock.acquire()
    self.Stopped=1
    self.Lock.release()

  def clear(self):

    self.stop()
    if self.Next:
      self.Next.clear()

  def run(self):

    stopped=0
    while not stopped:
      time.sleep(self.Interval)
      self.Lock.acquire()
      stopped=self.Stopped
      self.Lock.release()
      if not stopped:
        self.Model.event(self.Event, [], None, 0)
        stopped=not self.Repeat


class StateMachine:

  def eventStr2Int(self, event):

    return -1

  def getCurrentStateList(self):

    return None

  def getCurrentState(self):

    return "[]"

  def getEnabledEvents(self):

    return None

  def initModel(self, run_initializer=1, run_enter_actions=1):

    pass

  def isInState(self, s):

    return 0

  def getParentState(self, state):

    return -1

  def isHistoryState(self, state):

    return 0

  def isLeafState(self, state):

    return 0

  def getHierarchy(self, start_level=0, state_prefix=None):

    return None

  def topLevelHistory(self):

    pass

  def recordAllEnteredStates(self):

    pass

  def runAllEnterActions(self):

    pass

  def runInitializer(self):

    pass

  def runFinalizer(self):

    pass

  def runInteractor(self):

    pass

  def state(self):

    pass

  def handleEvent(self, se, params=[], lock=None, call_submodels=1):

    return 0

  def event(self, e, params=[], lock=None, call_submodels=1):

    pass


def startswith(s, ss):

  return ss==None or (s!=None and len(s)>=len(ss) and s[0:len(ss)]==ss)


# used only when --ext is set
from code import InteractiveInterpreter


# Main Class -- the top level model that is executed from the command line
class SSGridViewStateChart(StateMachine):

  # Constants for this model
  StateNum=14
  EventNames=["__INTERNAL_0_TIME_0",
              "__INTERNAL_0_TIME_1",
              "__INTERNAL_0_TIME_2",
              "doubleClick",
              "downKey",
              "keypress",
              "leftKey",
              "mouseClick",
              "mouseMove",
              "print",
              "quit",
              "rightKey",
              "start",
              "upKey" 
             ]
  StateNames=["Running",
              "Running.Control",
              "Running.Control.Editing",
              "Running.Control.Editing.Edit",
              "Running.Control.Editing.Edit.WaitForEdit",
              "Running.Control.Editing.FlashTime",
              "Running.Control.Editing.FlashTime.Flashing",
              "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite",
              "Running.Control.Editing.FlashTime.Flashing.WhiteOnBlack",
              "Running.Control.Viewing",
              "Running.Timer",
              "Running.Timer.IncrementTime",
              "Setup",
              "Stopped" 
             ]
  ParentTable=[-1,  # Running -- parent (None)
               0,  # Running.Control -- parent Running
               1,  # Running.Control.Editing -- parent Running.Control
               2,  # Running.Control.Editing.Edit -- parent Running.Control.Editing
               3,  # Running.Control.Editing.Edit.WaitForEdit -- parent Running.Control.Editing.Edit
               2,  # Running.Control.Editing.FlashTime -- parent Running.Control.Editing
               5,  # Running.Control.Editing.FlashTime.Flashing -- parent Running.Control.Editing.FlashTime
               6,  # Running.Control.Editing.FlashTime.Flashing.BlackOnWhite -- parent Running.Control.Editing.FlashTime.Flashing
               6,  # Running.Control.Editing.FlashTime.Flashing.WhiteOnBlack -- parent Running.Control.Editing.FlashTime.Flashing
               1,  # Running.Control.Viewing -- parent Running.Control
               0,  # Running.Timer -- parent Running
               10,  # Running.Timer.IncrementTime -- parent Running.Timer
               -1,  # Setup -- parent (None)
               -1   # Stopped -- parent (None)
              ]
  HistoryStateTable=[2,
                     0,
                     0,
                     0,
                     0,
                     0,
                     0,
                     0,
                     0,
                     0,
                     0,
                     0,
                     0,
                     0 
                    ]
  LeafStateTable=[None,
                  None,
                  None,
                  None,
                  "Running.Control.Editing.Edit.WaitForEdit",
                  None,
                  None,
                  "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite",
                  "Running.Control.Editing.FlashTime.Flashing.WhiteOnBlack",
                  "Running.Control.Viewing",
                  None,
                  "Running.Timer.IncrementTime",
                  "Setup",
                  "Stopped" 
                 ]
  OrthogonalInBetween=[[0, 0, 0, 0, 1, 0, 0, 1, 1, 1, 0, 1, 0, 0],
                       [0, 0, 0, 0, 1, 0, 0, 1, 1, 1, 0, 1, 0, 0],
                       [0, 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],
                       [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0] 
                      ]
  Hierarchy=[[0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0],  # substates of state Running
             [0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0],  # substates of state Running.Control
             [0, 0, 0, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0],  # substates of state Running.Control.Editing
             [0, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state Running.Control.Editing.Edit
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state Running.Control.Editing.Edit.WaitForEdit
             [0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 0, 0, 0],  # substates of state Running.Control.Editing.FlashTime
             [0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 0, 0, 0, 0],  # substates of state Running.Control.Editing.FlashTime.Flashing
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state Running.Control.Editing.FlashTime.Flashing.BlackOnWhite
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state Running.Control.Editing.FlashTime.Flashing.WhiteOnBlack
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state Running.Control.Viewing
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 0, 0],  # substates of state Running.Timer
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state Running.Timer.IncrementTime
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0],  # substates of state Setup
             [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]   # substates of state Stopped
            ]
  CommonStateTable=[[-1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, -1],
                    [0, 0, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, -1, -1],
                    [0, 1, 1, 2, 2, 2, 2, 2, 2, 1, 0, 0, -1, -1],
                    [0, 1, 2, 2, 3, 2, 2, 2, 2, 1, 0, 0, -1, -1],
                    [0, 1, 2, 3, 3, 2, 2, 2, 2, 1, 0, 0, -1, -1],
                    [0, 1, 2, 2, 2, 2, 5, 5, 5, 1, 0, 0, -1, -1],
                    [0, 1, 2, 2, 2, 5, 5, 6, 6, 1, 0, 0, -1, -1],
                    [0, 1, 2, 2, 2, 5, 6, 6, 6, 1, 0, 0, -1, -1],
                    [0, 1, 2, 2, 2, 5, 6, 6, 6, 1, 0, 0, -1, -1],
                    [0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, -1, -1],
                    [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, -1, -1],
                    [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 10, 10, -1, -1],
                    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1],
                    [-1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1] 
                   ]
  Description=None

  Lock=thread.allocate_lock()
  CurrentModel=None

  def __init__(self, Interpreter=None):

    # Variables
    self.state=None
    self.Submodels=[]
    for i in range(SSGridViewStateChart.StateNum):
      self.Submodels.append(None)
    self.history=[]
    for i in range(SSGridViewStateChart.StateNum):
      self.history.append(None)

    # Constructor
    for i in range(SSGridViewStateChart.StateNum):
      self.history[i]=History()
      self.history[i].States=[]
      self.history[i].Times=[]
      for j in range(SSGridViewStateChart.StateNum):
        self.history[i].States.append(-1)
        self.history[i].Times.append(-1)

    self.TimedTransitions=[] # used only when --ext is set
    for i in range(SSGridViewStateChart.StateNum):
      self.TimedTransitions.append(None)

    self.clearEnteredStates()

    # Interpreter of action code
    if Interpreter:
      self.DefaultInterpreter=Interpreter
    else:
      self.DefaultInterpreter=InteractiveInterpreter()
    self.HasInteractor=0
    self.setupInterpreter()

    self.EventsLock=thread.allocate_lock()
    self.PendingEvents=None
    self.PendingEventsTail=None
    self.HandleEventRunning=0
    self.Started=0

    self.description=SSGridViewStateChart.Description

  # Methods
  def isParent(self, sp, sc):

    return sc>=0 and (sp<0 or SSGridViewStateChart.Hierarchy[sp][sc])

  def isInState(self, s):

    if isinstance(s, int):
      st=self.state
      while st!=None:
        if st.StateID==s or self.isParent(s, st.StateID):
          return 1
        else:
          st=st.Next
      return 0

    elif isinstance(s, str):
      for i in range(SSGridViewStateChart.StateNum):
        if s==SSGridViewStateChart.StateNames[i]:
          return self.isInState(i)
      for i in range(SSGridViewStateChart.StateNum):
        if self.Submodels[i]!=None and startsWith(s, SSGridViewStateChart.StateNames[i]+"."):
          SubmodelState=s[len(SSGridViewStateChart.StateNames[i])+1:]
          return self.isInState(i) and self.Submodels[i].isInState(SubmodelState)
    return 0

  def main(self, argv):

    model=SSGridViewStateChart()
    cmd=""
    model.initModel()
    if model.HasInteractor:
      model.runInteractor()
    else:
      if SSGridViewStateChart.Description:
        sys.__stdout__.write(SSGridViewStateChart.Description+"\n")
      lock=thread.allocate_lock()
      while cmd!="exit":
        sys.__stdout__.write(model.getCurrentState()+" > ")
        cmd=string.strip(sys.__stdin__.readline())
        if cmd=="exit":
          break
        lock.acquire()
        model.event(cmd, [], lock)
        lock.acquire()
        lock.release()
    model.runFinalizer()

  def initModel(self, run_initializer=1, run_enter_actions=1):

    self.clearEnteredStates()
    self.addInState(12) # init state "Setup"
    self.recordEnteredState(12)
    if run_initializer:
      self.runInitializer()
    if not self.HasInteractor:
      self.start(None, run_enter_actions)

  def handleEvent(self, se, params=[], lock=None, call_submodels=1):

    if not self.Started:
      if lock:
        lock.release()
      return 0
    self.EventsLock.acquire()
    self.HandleEventRunning=1
    self.EventsLock.release()
    self.params=params
    e=self.eventStr2Int(se)
    if e==0: # event "__INTERNAL_0_TIME_0"
      if self.isInState(11):
        self.runActionCode(2) # output action(s)
        self.runExitActionsForStates(10)
	self.clearEnteredStates()
        self.changeState(11, 11)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==1: # event "__INTERNAL_0_TIME_1"
      if self.isInState(7):
        self.runExitActionsForStates(6)
	self.clearEnteredStates()
        self.changeState(7, 8)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==2: # event "__INTERNAL_0_TIME_2"
      if self.isInState(8):
        self.runExitActionsForStates(6)
	self.clearEnteredStates()
        self.changeState(8, 7)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==3: # event "doubleClick"
      if self.isInState(9):
        self.runActionCode(3) # output action(s)
        self.runExitActionsForStates(1)
	self.clearEnteredStates()
        self.changeState(9, 2)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(4) and self.testCondition(0):
        self.runActionCode(4) # output action(s)
        self.runExitActionsForStates(3)
	self.clearEnteredStates()
        self.changeState(4, 4)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==4: # event "downKey"
      if self.isInState(9):
        self.runActionCode(5) # output action(s)
        self.runExitActionsForStates(1)
	self.clearEnteredStates()
        self.changeState(9, 9)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(2) and self.testCondition(1):
        self.runActionCode(6) # output action(s)
        self.runExitActionsForStates(1)
	self.clearEnteredStates()
        self.changeState(2, 9)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==5: # event "keypress"
      if self.isInState(9) and self.testCondition(2):
        self.runActionCode(7) # output action(s)
        self.runExitActionsForStates(1)
	self.clearEnteredStates()
        self.changeState(9, 2)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(4) and self.testCondition(3):
        self.runActionCode(8) # output action(s)
        self.runExitActionsForStates(3)
	self.clearEnteredStates()
        self.changeState(4, 4)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(4) and self.testCondition(4):
        self.runActionCode(9) # output action(s)
        self.runExitActionsForStates(3)
	self.clearEnteredStates()
        self.changeState(4, 4)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(4) and self.testCondition(5):
        self.runActionCode(10) # output action(s)
        self.runExitActionsForStates(3)
	self.clearEnteredStates()
        self.changeState(4, 4)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==6: # event "leftKey"
      if self.isInState(9):
        self.runActionCode(11) # output action(s)
        self.runExitActionsForStates(1)
	self.clearEnteredStates()
        self.changeState(9, 9)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(2) and self.testCondition(6):
        self.runActionCode(12) # output action(s)
        self.runExitActionsForStates(1)
	self.clearEnteredStates()
        self.changeState(2, 9)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(4) and self.testCondition(7):
        self.runActionCode(13) # output action(s)
        self.runExitActionsForStates(3)
	self.clearEnteredStates()
        self.changeState(4, 4)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==7: # event "mouseClick"
      if self.isInState(9) and self.testCondition(8):
        self.runActionCode(14) # output action(s)
        self.runExitActionsForStates(1)
	self.clearEnteredStates()
        self.changeState(9, 9)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(9) and self.testCondition(9):
        self.runActionCode(15) # output action(s)
        self.runExitActionsForStates(1)
	self.clearEnteredStates()
        self.changeState(9, 2)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(2) and self.testCondition(10):
        self.runExitActionsForStates(1)
	self.clearEnteredStates()
        self.changeState(2, 2)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(2) and self.testCondition(11):
        self.runActionCode(16) # output action(s)
        self.runExitActionsForStates(1)
	self.clearEnteredStates()
        self.changeState(2, 9)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==8: # event "mouseMove"
      if self.isInState(9):
        self.runActionCode(17) # output action(s)
        self.runExitActionsForStates(1)
	self.clearEnteredStates()
        self.changeState(9, 9)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(4) and self.testCondition(12):
        self.runActionCode(18) # output action(s)
        self.runExitActionsForStates(3)
	self.clearEnteredStates()
        self.changeState(4, 4)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(4) and self.testCondition(13):
        self.runActionCode(19) # output action(s)
        self.runExitActionsForStates(3)
	self.clearEnteredStates()
        self.changeState(4, 4)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==9: # event "print"
      if self.isInState(0):
        self.runActionCode(20) # output action(s)
        self.runExitActionsForStates(-1)
	self.clearEnteredStates()
        self.changeState(0, 0, 1)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==10: # event "quit"
      if self.isInState(0):
        self.runExitActionsForStates(-1)
	self.clearEnteredStates()
        self.changeState(0, 13)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==11: # event "rightKey"
      if self.isInState(9):
        self.runActionCode(21) # output action(s)
        self.runExitActionsForStates(1)
	self.clearEnteredStates()
        self.changeState(9, 9)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(2) and self.testCondition(14):
        self.runActionCode(22) # output action(s)
        self.runExitActionsForStates(1)
	self.clearEnteredStates()
        self.changeState(2, 9)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(4) and self.testCondition(15):
        self.runActionCode(23) # output action(s)
        self.runExitActionsForStates(3)
	self.clearEnteredStates()
        self.changeState(4, 4)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==12: # event "start"
      if self.isInState(12):
        self.runActionCode(24) # output action(s)
        self.runExitActionsForStates(-1)
	self.clearEnteredStates()
        self.changeState(12, 0)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    elif e==13: # event "upKey"
      if self.isInState(9):
        self.runActionCode(25) # output action(s)
        self.runExitActionsForStates(1)
	self.clearEnteredStates()
        self.changeState(9, 9)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
      if self.isInState(2) and self.testCondition(16):
        self.runActionCode(26) # output action(s)
        self.runExitActionsForStates(1)
	self.clearEnteredStates()
        self.changeState(2, 9)
        self.runEnterActionsForStates(self.StatesEntered, 1)
        if lock:
          lock.release()
        self.checkPendingEvents()
        return 1
    if lock:
      lock.release()
    self.checkPendingEvents()
    return 0

  def forceIntoState(self, s):

    changed=0
    s2=self.state
    while s2!=None:
      HasCommonParent=0
      for i in range(SSGridViewStateChart.StateNum):
        if self.isParent(i, s2.StateID) and self.isParent(i, s):
          HasCommonParent=1
          if not self.hasOrthogonalStateInBetween(i, s2.StateID):
            self.changeState(s2.StateID, s)
            changed=1
      if not HasCommonParent:
        self.changeState(s2.StateID, s)
        changed=1
      s2=s2.Next
    if not changed:
      self.addInState(s)

  def changeState(self, s1, s2, check_history=0, top_level=0):

    # t1=common(s1, s2)
    t1=SSGridViewStateChart.CommonStateTable[s1][s2]
    self.recordHistory(t1)
    if t1>=0:
      self.removeOutStates(t1)
    else:
      self.state=None
    # t2=history(s2)
    t2=SSGridViewStateChart.HistoryStateTable[s2]
    if t2==0: # no history
      self.generateStates(t1, s2)
    elif t2==1: # normal history
      if not check_history:
        self.generateStates(t1, s2)
      elif self.hasHistoryRecorded(s2):
        self.generateStates(t1, self.history[s2].States[s2])
      else:
        self.generateStates(t1, s2, 1)
    elif t2==2: # deep history
      if check_history and self.hasHistoryRecorded(s2):
        for i in range(SSGridViewStateChart.StateNum):
          hs=self.history[s2].States[i]
          if hs>=0 and self.isLeafState(hs):
            # used only when --ext is set
            self.recordEnteredState(hs, 1, 1, t1)
            self.addInState(hs)
      else:
        self.generateStates(t1, s2)

  def addInState(self, s):

    if not self.isInState(s):
      st=State()
      st.StateID=s
      st.Next=self.state
      self.state=st
      return 1
    else:
      return 0

  def generateStates(self, common, dest, history_type=0):

    if common==-1:
      if dest==0:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(9):
                self.recordEnteredState(9)
                self.addInState(9)  # move into leaf state "Running.Control.Viewing"
            if history_type!=2 or self.check_history(10):
              self.recordEnteredState(10)
              if history_type!=2 or self.check_history(11):
                self.recordEnteredState(11)
                self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
      elif dest==1:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(9):
                self.recordEnteredState(9)
                self.addInState(9)  # move into leaf state "Running.Control.Viewing"
            if history_type!=2 or self.check_history(10):
              self.recordEnteredState(10)
              if history_type!=2 or self.check_history(11):
                self.recordEnteredState(11)
                self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
      elif dest==2:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(2):
                self.recordEnteredState(2)
                if history_type!=2 or self.check_history(3):
                  self.recordEnteredState(3)
                  if history_type!=2 or self.check_history(4):
                    self.recordEnteredState(4)
                    self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
                if history_type!=2 or self.check_history(5):
                  self.recordEnteredState(5)
                  if history_type!=2 or self.check_history(6):
                    self.recordEnteredState(6)
                    if history_type!=2 or self.check_history(7):
                      self.recordEnteredState(7)
                      self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
            if history_type!=2 or self.check_history(10):
              self.recordEnteredState(10)
              if history_type!=2 or self.check_history(11):
                self.recordEnteredState(11)
                self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
      elif dest==3:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(2):
                self.recordEnteredState(2)
                if history_type!=2 or self.check_history(3):
                  self.recordEnteredState(3)
                  if history_type!=2 or self.check_history(4):
                    self.recordEnteredState(4)
                    self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
                if history_type!=2 or self.check_history(5):
                  self.recordEnteredState(5)
                  if history_type!=2 or self.check_history(6):
                    self.recordEnteredState(6)
                    if history_type!=2 or self.check_history(7):
                      self.recordEnteredState(7)
                      self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
            if history_type!=2 or self.check_history(10):
              self.recordEnteredState(10)
              if history_type!=2 or self.check_history(11):
                self.recordEnteredState(11)
                self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
      elif dest==4:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(2):
                self.recordEnteredState(2)
                if history_type!=2 or self.check_history(3):
                  self.recordEnteredState(3)
                  if history_type!=2 or self.check_history(4):
                    self.recordEnteredState(4)
                    self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
                if history_type!=2 or self.check_history(5):
                  self.recordEnteredState(5)
                  if history_type!=2 or self.check_history(6):
                    self.recordEnteredState(6)
                    if history_type!=2 or self.check_history(7):
                      self.recordEnteredState(7)
                      self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
            if history_type!=2 or self.check_history(10):
              self.recordEnteredState(10)
              if history_type!=2 or self.check_history(11):
                self.recordEnteredState(11)
                self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
      elif dest==5:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(2):
                self.recordEnteredState(2)
                if history_type!=2 or self.check_history(3):
                  self.recordEnteredState(3)
                  if history_type!=2 or self.check_history(4):
                    self.recordEnteredState(4)
                    self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
                if history_type!=2 or self.check_history(5):
                  self.recordEnteredState(5)
                  if history_type!=2 or self.check_history(6):
                    self.recordEnteredState(6)
                    if history_type!=2 or self.check_history(7):
                      self.recordEnteredState(7)
                      self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
            if history_type!=2 or self.check_history(10):
              self.recordEnteredState(10)
              if history_type!=2 or self.check_history(11):
                self.recordEnteredState(11)
                self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
      elif dest==6:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(2):
                self.recordEnteredState(2)
                if history_type!=2 or self.check_history(3):
                  self.recordEnteredState(3)
                  if history_type!=2 or self.check_history(4):
                    self.recordEnteredState(4)
                    self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
                if history_type!=2 or self.check_history(5):
                  self.recordEnteredState(5)
                  if history_type!=2 or self.check_history(6):
                    self.recordEnteredState(6)
                    if history_type!=2 or self.check_history(7):
                      self.recordEnteredState(7)
                      self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
            if history_type!=2 or self.check_history(10):
              self.recordEnteredState(10)
              if history_type!=2 or self.check_history(11):
                self.recordEnteredState(11)
                self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
      elif dest==7:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(2):
                self.recordEnteredState(2)
                if history_type!=2 or self.check_history(3):
                  self.recordEnteredState(3)
                  if history_type!=2 or self.check_history(4):
                    self.recordEnteredState(4)
                    self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
                if history_type!=2 or self.check_history(5):
                  self.recordEnteredState(5)
                  if history_type!=2 or self.check_history(6):
                    self.recordEnteredState(6)
                    if history_type!=2 or self.check_history(7):
                      self.recordEnteredState(7)
                      self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
            if history_type!=2 or self.check_history(10):
              self.recordEnteredState(10)
              if history_type!=2 or self.check_history(11):
                self.recordEnteredState(11)
                self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
      elif dest==8:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(2):
                self.recordEnteredState(2)
                if history_type!=2 or self.check_history(3):
                  self.recordEnteredState(3)
                  if history_type!=2 or self.check_history(4):
                    self.recordEnteredState(4)
                    self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
                if history_type!=2 or self.check_history(5):
                  self.recordEnteredState(5)
                  if history_type!=2 or self.check_history(6):
                    self.recordEnteredState(6)
                    if history_type!=2 or self.check_history(8):
                      self.recordEnteredState(8)
                      self.addInState(8)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.WhiteOnBlack"
            if history_type!=2 or self.check_history(10):
              self.recordEnteredState(10)
              if history_type!=2 or self.check_history(11):
                self.recordEnteredState(11)
                self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
      elif dest==9:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(9):
                self.recordEnteredState(9)
                self.addInState(9)  # move into leaf state "Running.Control.Viewing"
            if history_type!=2 or self.check_history(10):
              self.recordEnteredState(10)
              if history_type!=2 or self.check_history(11):
                self.recordEnteredState(11)
                self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
      elif dest==10:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(9):
                self.recordEnteredState(9)
                self.addInState(9)  # move into leaf state "Running.Control.Viewing"
            if history_type!=2 or self.check_history(10):
              self.recordEnteredState(10)
              if history_type!=2 or self.check_history(11):
                self.recordEnteredState(11)
                self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
      elif dest==11:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(0):
            self.recordEnteredState(0)
            if history_type!=2 or self.check_history(1):
              self.recordEnteredState(1)
              if history_type!=2 or self.check_history(9):
                self.recordEnteredState(9)
                self.addInState(9)  # move into leaf state "Running.Control.Viewing"
            if history_type!=2 or self.check_history(10):
              self.recordEnteredState(10)
              if history_type!=2 or self.check_history(11):
                self.recordEnteredState(11)
                self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
      elif dest==12:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(12):
            self.recordEnteredState(12)
            self.addInState(12)  # move into leaf state "Setup"
      elif dest==13:
        if history_type!=2 or self.check_history(-1):
          if history_type!=2 or self.check_history(13):
            self.recordEnteredState(13)
            self.addInState(13)  # move into leaf state "Stopped"
    elif common==0:
      if dest==0:
        if history_type!=2 or self.check_history(0):
          self.recordEnteredState(0)
          if history_type!=2 or self.check_history(1):
            self.recordEnteredState(1)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "Running.Control.Viewing"
          if history_type!=2 or self.check_history(10):
            self.recordEnteredState(10)
            if history_type!=2 or self.check_history(11):
              self.recordEnteredState(11)
              self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
      elif dest==1:
        if history_type!=2 or self.check_history(0):
          self.recordEnteredState(0)
          if history_type!=2 or self.check_history(1):
            self.recordEnteredState(1)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "Running.Control.Viewing"
          if history_type!=2 or self.check_history(10):
            self.recordEnteredState(10)
            if history_type!=2 or self.check_history(11):
              self.recordEnteredState(11)
              self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
      elif dest==2:
        if history_type!=2 or self.check_history(0):
          self.recordEnteredState(0)
          if history_type!=2 or self.check_history(1):
            self.recordEnteredState(1)
            if history_type!=2 or self.check_history(2):
              self.recordEnteredState(2)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                if history_type!=2 or self.check_history(4):
                  self.recordEnteredState(4)
                  self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
              if history_type!=2 or self.check_history(5):
                self.recordEnteredState(5)
                if history_type!=2 or self.check_history(6):
                  self.recordEnteredState(6)
                  if history_type!=2 or self.check_history(7):
                    self.recordEnteredState(7)
                    self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
          if history_type!=2 or self.check_history(10):
            self.recordEnteredState(10)
            if history_type!=2 or self.check_history(11):
              self.recordEnteredState(11)
              self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
      elif dest==3:
        if history_type!=2 or self.check_history(0):
          self.recordEnteredState(0)
          if history_type!=2 or self.check_history(1):
            self.recordEnteredState(1)
            if history_type!=2 or self.check_history(2):
              self.recordEnteredState(2)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                if history_type!=2 or self.check_history(4):
                  self.recordEnteredState(4)
                  self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
              if history_type!=2 or self.check_history(5):
                self.recordEnteredState(5)
                if history_type!=2 or self.check_history(6):
                  self.recordEnteredState(6)
                  if history_type!=2 or self.check_history(7):
                    self.recordEnteredState(7)
                    self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
          if history_type!=2 or self.check_history(10):
            self.recordEnteredState(10)
            if history_type!=2 or self.check_history(11):
              self.recordEnteredState(11)
              self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
      elif dest==4:
        if history_type!=2 or self.check_history(0):
          self.recordEnteredState(0)
          if history_type!=2 or self.check_history(1):
            self.recordEnteredState(1)
            if history_type!=2 or self.check_history(2):
              self.recordEnteredState(2)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                if history_type!=2 or self.check_history(4):
                  self.recordEnteredState(4)
                  self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
              if history_type!=2 or self.check_history(5):
                self.recordEnteredState(5)
                if history_type!=2 or self.check_history(6):
                  self.recordEnteredState(6)
                  if history_type!=2 or self.check_history(7):
                    self.recordEnteredState(7)
                    self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
          if history_type!=2 or self.check_history(10):
            self.recordEnteredState(10)
            if history_type!=2 or self.check_history(11):
              self.recordEnteredState(11)
              self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
      elif dest==5:
        if history_type!=2 or self.check_history(0):
          self.recordEnteredState(0)
          if history_type!=2 or self.check_history(1):
            self.recordEnteredState(1)
            if history_type!=2 or self.check_history(2):
              self.recordEnteredState(2)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                if history_type!=2 or self.check_history(4):
                  self.recordEnteredState(4)
                  self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
              if history_type!=2 or self.check_history(5):
                self.recordEnteredState(5)
                if history_type!=2 or self.check_history(6):
                  self.recordEnteredState(6)
                  if history_type!=2 or self.check_history(7):
                    self.recordEnteredState(7)
                    self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
          if history_type!=2 or self.check_history(10):
            self.recordEnteredState(10)
            if history_type!=2 or self.check_history(11):
              self.recordEnteredState(11)
              self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
      elif dest==6:
        if history_type!=2 or self.check_history(0):
          self.recordEnteredState(0)
          if history_type!=2 or self.check_history(1):
            self.recordEnteredState(1)
            if history_type!=2 or self.check_history(2):
              self.recordEnteredState(2)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                if history_type!=2 or self.check_history(4):
                  self.recordEnteredState(4)
                  self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
              if history_type!=2 or self.check_history(5):
                self.recordEnteredState(5)
                if history_type!=2 or self.check_history(6):
                  self.recordEnteredState(6)
                  if history_type!=2 or self.check_history(7):
                    self.recordEnteredState(7)
                    self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
          if history_type!=2 or self.check_history(10):
            self.recordEnteredState(10)
            if history_type!=2 or self.check_history(11):
              self.recordEnteredState(11)
              self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
      elif dest==7:
        if history_type!=2 or self.check_history(0):
          self.recordEnteredState(0)
          if history_type!=2 or self.check_history(1):
            self.recordEnteredState(1)
            if history_type!=2 or self.check_history(2):
              self.recordEnteredState(2)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                if history_type!=2 or self.check_history(4):
                  self.recordEnteredState(4)
                  self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
              if history_type!=2 or self.check_history(5):
                self.recordEnteredState(5)
                if history_type!=2 or self.check_history(6):
                  self.recordEnteredState(6)
                  if history_type!=2 or self.check_history(7):
                    self.recordEnteredState(7)
                    self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
          if history_type!=2 or self.check_history(10):
            self.recordEnteredState(10)
            if history_type!=2 or self.check_history(11):
              self.recordEnteredState(11)
              self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
      elif dest==8:
        if history_type!=2 or self.check_history(0):
          self.recordEnteredState(0)
          if history_type!=2 or self.check_history(1):
            self.recordEnteredState(1)
            if history_type!=2 or self.check_history(2):
              self.recordEnteredState(2)
              if history_type!=2 or self.check_history(3):
                self.recordEnteredState(3)
                if history_type!=2 or self.check_history(4):
                  self.recordEnteredState(4)
                  self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
              if history_type!=2 or self.check_history(5):
                self.recordEnteredState(5)
                if history_type!=2 or self.check_history(6):
                  self.recordEnteredState(6)
                  if history_type!=2 or self.check_history(8):
                    self.recordEnteredState(8)
                    self.addInState(8)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.WhiteOnBlack"
          if history_type!=2 or self.check_history(10):
            self.recordEnteredState(10)
            if history_type!=2 or self.check_history(11):
              self.recordEnteredState(11)
              self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
      elif dest==9:
        if history_type!=2 or self.check_history(0):
          self.recordEnteredState(0)
          if history_type!=2 or self.check_history(1):
            self.recordEnteredState(1)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "Running.Control.Viewing"
          if history_type!=2 or self.check_history(10):
            self.recordEnteredState(10)
            if history_type!=2 or self.check_history(11):
              self.recordEnteredState(11)
              self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
      elif dest==10:
        if history_type!=2 or self.check_history(0):
          self.recordEnteredState(0)
          if history_type!=2 or self.check_history(1):
            self.recordEnteredState(1)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "Running.Control.Viewing"
          if history_type!=2 or self.check_history(10):
            self.recordEnteredState(10)
            if history_type!=2 or self.check_history(11):
              self.recordEnteredState(11)
              self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
      elif dest==11:
        if history_type!=2 or self.check_history(0):
          self.recordEnteredState(0)
          if history_type!=2 or self.check_history(1):
            self.recordEnteredState(1)
            if history_type!=2 or self.check_history(9):
              self.recordEnteredState(9)
              self.addInState(9)  # move into leaf state "Running.Control.Viewing"
          if history_type!=2 or self.check_history(10):
            self.recordEnteredState(10)
            if history_type!=2 or self.check_history(11):
              self.recordEnteredState(11)
              self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
    elif common==1:
      if dest==1:
        if history_type!=2 or self.check_history(1):
          self.recordEnteredState(1)
          if history_type!=2 or self.check_history(9):
            self.recordEnteredState(9)
            self.addInState(9)  # move into leaf state "Running.Control.Viewing"
      elif dest==2:
        if history_type!=2 or self.check_history(1):
          self.recordEnteredState(1)
          if history_type!=2 or self.check_history(2):
            self.recordEnteredState(2)
            if history_type!=2 or self.check_history(3):
              self.recordEnteredState(3)
              if history_type!=2 or self.check_history(4):
                self.recordEnteredState(4)
                self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
            if history_type!=2 or self.check_history(5):
              self.recordEnteredState(5)
              if history_type!=2 or self.check_history(6):
                self.recordEnteredState(6)
                if history_type!=2 or self.check_history(7):
                  self.recordEnteredState(7)
                  self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
      elif dest==3:
        if history_type!=2 or self.check_history(1):
          self.recordEnteredState(1)
          if history_type!=2 or self.check_history(2):
            self.recordEnteredState(2)
            if history_type!=2 or self.check_history(3):
              self.recordEnteredState(3)
              if history_type!=2 or self.check_history(4):
                self.recordEnteredState(4)
                self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
            if history_type!=2 or self.check_history(5):
              self.recordEnteredState(5)
              if history_type!=2 or self.check_history(6):
                self.recordEnteredState(6)
                if history_type!=2 or self.check_history(7):
                  self.recordEnteredState(7)
                  self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
      elif dest==4:
        if history_type!=2 or self.check_history(1):
          self.recordEnteredState(1)
          if history_type!=2 or self.check_history(2):
            self.recordEnteredState(2)
            if history_type!=2 or self.check_history(3):
              self.recordEnteredState(3)
              if history_type!=2 or self.check_history(4):
                self.recordEnteredState(4)
                self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
            if history_type!=2 or self.check_history(5):
              self.recordEnteredState(5)
              if history_type!=2 or self.check_history(6):
                self.recordEnteredState(6)
                if history_type!=2 or self.check_history(7):
                  self.recordEnteredState(7)
                  self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
      elif dest==5:
        if history_type!=2 or self.check_history(1):
          self.recordEnteredState(1)
          if history_type!=2 or self.check_history(2):
            self.recordEnteredState(2)
            if history_type!=2 or self.check_history(3):
              self.recordEnteredState(3)
              if history_type!=2 or self.check_history(4):
                self.recordEnteredState(4)
                self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
            if history_type!=2 or self.check_history(5):
              self.recordEnteredState(5)
              if history_type!=2 or self.check_history(6):
                self.recordEnteredState(6)
                if history_type!=2 or self.check_history(7):
                  self.recordEnteredState(7)
                  self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
      elif dest==6:
        if history_type!=2 or self.check_history(1):
          self.recordEnteredState(1)
          if history_type!=2 or self.check_history(2):
            self.recordEnteredState(2)
            if history_type!=2 or self.check_history(3):
              self.recordEnteredState(3)
              if history_type!=2 or self.check_history(4):
                self.recordEnteredState(4)
                self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
            if history_type!=2 or self.check_history(5):
              self.recordEnteredState(5)
              if history_type!=2 or self.check_history(6):
                self.recordEnteredState(6)
                if history_type!=2 or self.check_history(7):
                  self.recordEnteredState(7)
                  self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
      elif dest==7:
        if history_type!=2 or self.check_history(1):
          self.recordEnteredState(1)
          if history_type!=2 or self.check_history(2):
            self.recordEnteredState(2)
            if history_type!=2 or self.check_history(3):
              self.recordEnteredState(3)
              if history_type!=2 or self.check_history(4):
                self.recordEnteredState(4)
                self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
            if history_type!=2 or self.check_history(5):
              self.recordEnteredState(5)
              if history_type!=2 or self.check_history(6):
                self.recordEnteredState(6)
                if history_type!=2 or self.check_history(7):
                  self.recordEnteredState(7)
                  self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
      elif dest==8:
        if history_type!=2 or self.check_history(1):
          self.recordEnteredState(1)
          if history_type!=2 or self.check_history(2):
            self.recordEnteredState(2)
            if history_type!=2 or self.check_history(3):
              self.recordEnteredState(3)
              if history_type!=2 or self.check_history(4):
                self.recordEnteredState(4)
                self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
            if history_type!=2 or self.check_history(5):
              self.recordEnteredState(5)
              if history_type!=2 or self.check_history(6):
                self.recordEnteredState(6)
                if history_type!=2 or self.check_history(8):
                  self.recordEnteredState(8)
                  self.addInState(8)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.WhiteOnBlack"
      elif dest==9:
        if history_type!=2 or self.check_history(1):
          self.recordEnteredState(1)
          if history_type!=2 or self.check_history(9):
            self.recordEnteredState(9)
            self.addInState(9)  # move into leaf state "Running.Control.Viewing"
    elif common==2:
      if dest==2:
        if history_type!=2 or self.check_history(2):
          self.recordEnteredState(2)
          if history_type!=2 or self.check_history(3):
            self.recordEnteredState(3)
            if history_type!=2 or self.check_history(4):
              self.recordEnteredState(4)
              self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              if history_type!=2 or self.check_history(7):
                self.recordEnteredState(7)
                self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
      elif dest==3:
        if history_type!=2 or self.check_history(2):
          self.recordEnteredState(2)
          if history_type!=2 or self.check_history(3):
            self.recordEnteredState(3)
            if history_type!=2 or self.check_history(4):
              self.recordEnteredState(4)
              self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              if history_type!=2 or self.check_history(7):
                self.recordEnteredState(7)
                self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
      elif dest==4:
        if history_type!=2 or self.check_history(2):
          self.recordEnteredState(2)
          if history_type!=2 or self.check_history(3):
            self.recordEnteredState(3)
            if history_type!=2 or self.check_history(4):
              self.recordEnteredState(4)
              self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              if history_type!=2 or self.check_history(7):
                self.recordEnteredState(7)
                self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
      elif dest==5:
        if history_type!=2 or self.check_history(2):
          self.recordEnteredState(2)
          if history_type!=2 or self.check_history(3):
            self.recordEnteredState(3)
            if history_type!=2 or self.check_history(4):
              self.recordEnteredState(4)
              self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              if history_type!=2 or self.check_history(7):
                self.recordEnteredState(7)
                self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
      elif dest==6:
        if history_type!=2 or self.check_history(2):
          self.recordEnteredState(2)
          if history_type!=2 or self.check_history(3):
            self.recordEnteredState(3)
            if history_type!=2 or self.check_history(4):
              self.recordEnteredState(4)
              self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              if history_type!=2 or self.check_history(7):
                self.recordEnteredState(7)
                self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
      elif dest==7:
        if history_type!=2 or self.check_history(2):
          self.recordEnteredState(2)
          if history_type!=2 or self.check_history(3):
            self.recordEnteredState(3)
            if history_type!=2 or self.check_history(4):
              self.recordEnteredState(4)
              self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              if history_type!=2 or self.check_history(7):
                self.recordEnteredState(7)
                self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
      elif dest==8:
        if history_type!=2 or self.check_history(2):
          self.recordEnteredState(2)
          if history_type!=2 or self.check_history(3):
            self.recordEnteredState(3)
            if history_type!=2 or self.check_history(4):
              self.recordEnteredState(4)
              self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
          if history_type!=2 or self.check_history(5):
            self.recordEnteredState(5)
            if history_type!=2 or self.check_history(6):
              self.recordEnteredState(6)
              if history_type!=2 or self.check_history(8):
                self.recordEnteredState(8)
                self.addInState(8)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.WhiteOnBlack"
    elif common==3:
      if dest==3:
        if history_type!=2 or self.check_history(3):
          self.recordEnteredState(3)
          if history_type!=2 or self.check_history(4):
            self.recordEnteredState(4)
            self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
      elif dest==4:
        if history_type!=2 or self.check_history(3):
          self.recordEnteredState(3)
          if history_type!=2 or self.check_history(4):
            self.recordEnteredState(4)
            self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
    elif common==4:
      if dest==4:
        if history_type!=2 or self.check_history(4):
          self.recordEnteredState(4)
          self.addInState(4)  # move into leaf state "Running.Control.Editing.Edit.WaitForEdit"
    elif common==5:
      if dest==5:
        if history_type!=2 or self.check_history(5):
          self.recordEnteredState(5)
          if history_type!=2 or self.check_history(6):
            self.recordEnteredState(6)
            if history_type!=2 or self.check_history(7):
              self.recordEnteredState(7)
              self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
      elif dest==6:
        if history_type!=2 or self.check_history(5):
          self.recordEnteredState(5)
          if history_type!=2 or self.check_history(6):
            self.recordEnteredState(6)
            if history_type!=2 or self.check_history(7):
              self.recordEnteredState(7)
              self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
      elif dest==7:
        if history_type!=2 or self.check_history(5):
          self.recordEnteredState(5)
          if history_type!=2 or self.check_history(6):
            self.recordEnteredState(6)
            if history_type!=2 or self.check_history(7):
              self.recordEnteredState(7)
              self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
      elif dest==8:
        if history_type!=2 or self.check_history(5):
          self.recordEnteredState(5)
          if history_type!=2 or self.check_history(6):
            self.recordEnteredState(6)
            if history_type!=2 or self.check_history(8):
              self.recordEnteredState(8)
              self.addInState(8)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.WhiteOnBlack"
    elif common==6:
      if dest==6:
        if history_type!=2 or self.check_history(6):
          self.recordEnteredState(6)
          if history_type!=2 or self.check_history(7):
            self.recordEnteredState(7)
            self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
      elif dest==7:
        if history_type!=2 or self.check_history(6):
          self.recordEnteredState(6)
          if history_type!=2 or self.check_history(7):
            self.recordEnteredState(7)
            self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
      elif dest==8:
        if history_type!=2 or self.check_history(6):
          self.recordEnteredState(6)
          if history_type!=2 or self.check_history(8):
            self.recordEnteredState(8)
            self.addInState(8)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.WhiteOnBlack"
    elif common==7:
      if dest==7:
        if history_type!=2 or self.check_history(7):
          self.recordEnteredState(7)
          self.addInState(7)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
    elif common==8:
      if dest==8:
        if history_type!=2 or self.check_history(8):
          self.recordEnteredState(8)
          self.addInState(8)  # move into leaf state "Running.Control.Editing.FlashTime.Flashing.WhiteOnBlack"
    elif common==9:
      if dest==9:
        if history_type!=2 or self.check_history(9):
          self.recordEnteredState(9)
          self.addInState(9)  # move into leaf state "Running.Control.Viewing"
    elif common==10:
      if dest==10:
        if history_type!=2 or self.check_history(10):
          self.recordEnteredState(10)
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
      elif dest==11:
        if history_type!=2 or self.check_history(10):
          self.recordEnteredState(10)
          if history_type!=2 or self.check_history(11):
            self.recordEnteredState(11)
            self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
    elif common==11:
      if dest==11:
        if history_type!=2 or self.check_history(11):
          self.recordEnteredState(11)
          self.addInState(11)  # move into leaf state "Running.Timer.IncrementTime"
    elif common==12:
      if dest==12:
        if history_type!=2 or self.check_history(12):
          self.recordEnteredState(12)
          self.addInState(12)  # move into leaf state "Setup"
    elif common==13:
      if dest==13:
        if history_type!=2 or self.check_history(13):
          self.recordEnteredState(13)
          self.addInState(13)  # move into leaf state "Stopped"

  def removeOutStates(self, common_state):

    s=self.state
    prev=None
    while s!=None:
      if self.isParent(common_state, s.StateID):
        if prev==None:
          self.state=self.state.Next
        else:
          prev.Next=s.Next
      else:
        prev=s
      s=s.Next

  def eventStr2Int(self, event):

    for i in range(14):
      if event==SSGridViewStateChart.EventNames[i]:
        return i
    return -1

  def stateInt2Str(self, state):

    if state==-1:
      return ""
    else:
      return SSGridViewStateChart.StateNames[state]

  def getCurrentStateList(self):

    sl=StringList()
    slend=sl
    s=self.state
    while s!=None:
      sm=self.Submodels[s.StateID]
      curstate=self.stateInt2Str(s.StateID)
      if sm!=None:
        slend.Next=sm.getCurrentStateList()
        while slend.Next!=None:
          slend.Next.str=curstate+"."+slend.Next.str
          slend=slend.Next
      else:
        slend.Next=StringList(curstate)
        slend=slend.Next
      s=s.Next
    return sl.Next

  def getCurrentState(self, states=None):

    if states==None:
      states=self.getCurrentStateList()
      if states!=None:
        strst="[%s'%s']" % (self.getCurrentState(states), states.str)
      else:
        strst="[]"
    else:
      if states.Next:
        strst="%s'%s', " % (self.getCurrentState(states.Next), states.Next.str)
      else:
        strst=""
    return strst

  def getParentState(self, state):

    return SSGridViewStateChart.ParentTable[state]

  def getSubstates(self, state):

    substates=None
    if state==-1: # substates of ""
      # add substate "Running"
      st=IntList()
      st.int=0
      st.Next=substates
      substates=st
      # add substate "Setup"
      st=IntList()
      st.int=12
      st.Next=substates
      substates=st
      # add substate "Stopped"
      st=IntList()
      st.int=13
      st.Next=substates
      substates=st
    elif state==0: # substates of "Running"
      # add substate "Running.Control"
      st=IntList()
      st.int=1
      st.Next=substates
      substates=st
      # add substate "Running.Timer"
      st=IntList()
      st.int=10
      st.Next=substates
      substates=st
    elif state==1: # substates of "Running.Control"
      # add substate "Running.Control.Editing"
      st=IntList()
      st.int=2
      st.Next=substates
      substates=st
      # add substate "Running.Control.Viewing"
      st=IntList()
      st.int=9
      st.Next=substates
      substates=st
    elif state==2: # substates of "Running.Control.Editing"
      # add substate "Running.Control.Editing.Edit"
      st=IntList()
      st.int=3
      st.Next=substates
      substates=st
      # add substate "Running.Control.Editing.FlashTime"
      st=IntList()
      st.int=5
      st.Next=substates
      substates=st
    elif state==3: # substates of "Running.Control.Editing.Edit"
      # add substate "Running.Control.Editing.Edit.WaitForEdit"
      st=IntList()
      st.int=4
      st.Next=substates
      substates=st
    elif state==4: # substates of "Running.Control.Editing.Edit.WaitForEdit"
      pass
    elif state==5: # substates of "Running.Control.Editing.FlashTime"
      # add substate "Running.Control.Editing.FlashTime.Flashing"
      st=IntList()
      st.int=6
      st.Next=substates
      substates=st
    elif state==6: # substates of "Running.Control.Editing.FlashTime.Flashing"
      # add substate "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
      st=IntList()
      st.int=7
      st.Next=substates
      substates=st
      # add substate "Running.Control.Editing.FlashTime.Flashing.WhiteOnBlack"
      st=IntList()
      st.int=8
      st.Next=substates
      substates=st
    elif state==7: # substates of "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
      pass
    elif state==8: # substates of "Running.Control.Editing.FlashTime.Flashing.WhiteOnBlack"
      pass
    elif state==9: # substates of "Running.Control.Viewing"
      pass
    elif state==10: # substates of "Running.Timer"
      # add substate "Running.Timer.IncrementTime"
      st=IntList()
      st.int=11
      st.Next=substates
      substates=st
    elif state==11: # substates of "Running.Timer.IncrementTime"
      pass
    elif state==12: # substates of "Setup"
      pass
    elif state==13: # substates of "Stopped"
      pass
    return substates

  def isHistoryState(self, state):

    return SSGridViewStateChart.HistoryStateTable[state]>0

  def isLeafState(self, state):

    if isinstance(state, int):
      return SSGridViewStateChart.LeafStateTable[state]!=None

    elif isinstance(state, str):
      for i in range(SSGridViewStateChart.StateNum):
        if SSGridViewStateChart.LeafStateTable[i]==None:
          continue
        if state==SSGridViewStateChart.LeafStateTable[i] and self.Submodels[i]==None:
          return 1
        elif startswith(state, SSGridViewStateChart.LeafStateTable[i]+".") and self.Submodels[i]!=None:
          SubmodelState=state[SSGridViewStateChart.LeafStateTable[i].length()+1:]
          return self.Submodels[i].isLeafState(SubmodelState)
    return 0

  def isHistoryUp2Date(self, state, time):

    for i in range(SSGridViewStateChart.StateNum):
      if self.history[state].Times[i]>=time:
        return 1
    return 0

  def mergeHistory(self, state, states, times):

    max=-1
    for i in range(SSGridViewStateChart.StateNum):
      if times[i]>max:
        max=times[i]
    if self.isHistoryUp2Date(state, max):
      for i in range(SSGridViewStateChart.StateNum):
        if times[i]>self.history[state].Times[i]:
          self.history[state].States[i]=states[i]
          self.history[state].Times[i]=times[i]
    else:
      self.history[state].States=copy.copy(states)
      self.history[state].Times=copy.copy(times)

  def recordHistory(self, top_state):

    curtime=time.time();
    s=self.state;
    while s!=None:
      child=s.StateID
      states=[]
      times=[]
      for i in range(SSGridViewStateChart.StateNum):
        states.append(-1)
        times.append(-1)
      states[child]=child
      times[child]=curtime
      if top_state<0 or self.isParent(top_state, child):
        parent=self.getParentState(child)
        if self.isHistoryState(child):
          self.history[child].Submodel=self.Submodels[child]
        while parent!=top_state and times[parent]!=curtime:
          states[parent]=child
          times[parent]=curtime
          if self.isHistoryState(parent):
            self.mergeHistory(parent, states, times)
          child=parent
          parent=self.getParentState(child)
      s=s.Next

  def hasHistoryRecorded(self, state):

    for i in range(SSGridViewStateChart.StateNum):
      if self.history[state].States[i]!=-1:
        return 1
      if self.Submodels[state]!=None:
        return 1
    return 0

  def hasOrthogonalStateInBetween(self, parent, leaf):

    return SSGridViewStateChart.OrthogonalInBetween[parent+1][leaf]

  def check_history(self, dest):

    s=self.state
    while s!=None:
      if self.isParent(dest, s.StateID) and not self.hasOrthogonalStateInBetween(dest, s.StateID):
        return 0
      s=s.Next
    return 1

  def getEnabledEvents(self):

    events=EventList()
    if self.isInState(11):
      events.Append("__INTERNAL_0_TIME_0")
    if self.isInState(7):
      events.Append("__INTERNAL_0_TIME_1")
    if self.isInState(8):
      events.Append("__INTERNAL_0_TIME_2")
    if self.isInState(9):
      events.Append("doubleClick")
    if self.isInState(4):
      events.Append("doubleClick")
    if self.isInState(9):
      events.Append("downKey")
    if self.isInState(2):
      events.Append("downKey")
    if self.isInState(9):
      events.Append("keypress")
    if self.isInState(4):
      events.Append("keypress")
    if self.isInState(4):
      events.Append("keypress")
    if self.isInState(4):
      events.Append("keypress")
    if self.isInState(9):
      events.Append("leftKey")
    if self.isInState(2):
      events.Append("leftKey")
    if self.isInState(4):
      events.Append("leftKey")
    if self.isInState(9):
      events.Append("mouseClick")
    if self.isInState(9):
      events.Append("mouseClick")
    if self.isInState(2):
      events.Append("mouseClick")
    if self.isInState(2):
      events.Append("mouseClick")
    if self.isInState(9):
      events.Append("mouseMove")
    if self.isInState(4):
      events.Append("mouseMove")
    if self.isInState(4):
      events.Append("mouseMove")
    if self.isInState(0):
      events.Append("print")
    if self.isInState(0):
      events.Append("quit")
    if self.isInState(9):
      events.Append("rightKey")
    if self.isInState(2):
      events.Append("rightKey")
    if self.isInState(4):
      events.Append("rightKey")
    if self.isInState(12):
      events.Append("start")
    if self.isInState(9):
      events.Append("upKey")
    if self.isInState(2):
      events.Append("upKey")
    return events.Next

  def getHierarchy(self, start_level, state_prefix):

    h=Hierarchy()
    lasth=h
    # Generate state "Running" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="Running"
    if state_prefix==None:
      lasth.Next.PathName="Running"
    else:
      lasth.Next.PathName=state_prefix+".Running"
    lasth.Next.StateNum=0
    lasth.Next.Level=start_level+0
    lasth=lasth.Next
    # Generate state "Running.Control" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="Control"
    if state_prefix==None:
      lasth.Next.PathName="Running.Control"
    else:
      lasth.Next.PathName=state_prefix+".Running.Control"
    lasth.Next.StateNum=1
    lasth.Next.Level=start_level+1
    lasth=lasth.Next
    # Generate state "Running.Control.Editing" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="Editing"
    if state_prefix==None:
      lasth.Next.PathName="Running.Control.Editing"
    else:
      lasth.Next.PathName=state_prefix+".Running.Control.Editing"
    lasth.Next.StateNum=2
    lasth.Next.Level=start_level+2
    lasth=lasth.Next
    # Generate state "Running.Control.Editing.Edit" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="Edit"
    if state_prefix==None:
      lasth.Next.PathName="Running.Control.Editing.Edit"
    else:
      lasth.Next.PathName=state_prefix+".Running.Control.Editing.Edit"
    lasth.Next.StateNum=3
    lasth.Next.Level=start_level+3
    lasth=lasth.Next
    # Generate state "Running.Control.Editing.Edit.WaitForEdit" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="WaitForEdit"
    if state_prefix==None:
      lasth.Next.PathName="Running.Control.Editing.Edit.WaitForEdit"
    else:
      lasth.Next.PathName=state_prefix+".Running.Control.Editing.Edit.WaitForEdit"
    lasth.Next.StateNum=4
    lasth.Next.Level=start_level+4
    lasth=lasth.Next
    # Generate state "Running.Control.Editing.FlashTime" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="FlashTime"
    if state_prefix==None:
      lasth.Next.PathName="Running.Control.Editing.FlashTime"
    else:
      lasth.Next.PathName=state_prefix+".Running.Control.Editing.FlashTime"
    lasth.Next.StateNum=5
    lasth.Next.Level=start_level+3
    lasth=lasth.Next
    # Generate state "Running.Control.Editing.FlashTime.Flashing" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="Flashing"
    if state_prefix==None:
      lasth.Next.PathName="Running.Control.Editing.FlashTime.Flashing"
    else:
      lasth.Next.PathName=state_prefix+".Running.Control.Editing.FlashTime.Flashing"
    lasth.Next.StateNum=6
    lasth.Next.Level=start_level+4
    lasth=lasth.Next
    # Generate state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="BlackOnWhite"
    if state_prefix==None:
      lasth.Next.PathName="Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
    else:
      lasth.Next.PathName=state_prefix+".Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
    lasth.Next.StateNum=7
    lasth.Next.Level=start_level+5
    lasth=lasth.Next
    # Generate state "Running.Control.Editing.FlashTime.Flashing.WhiteOnBlack" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="WhiteOnBlack"
    if state_prefix==None:
      lasth.Next.PathName="Running.Control.Editing.FlashTime.Flashing.WhiteOnBlack"
    else:
      lasth.Next.PathName=state_prefix+".Running.Control.Editing.FlashTime.Flashing.WhiteOnBlack"
    lasth.Next.StateNum=8
    lasth.Next.Level=start_level+5
    lasth=lasth.Next
    # Generate state "Running.Control.Viewing" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="Viewing"
    if state_prefix==None:
      lasth.Next.PathName="Running.Control.Viewing"
    else:
      lasth.Next.PathName=state_prefix+".Running.Control.Viewing"
    lasth.Next.StateNum=9
    lasth.Next.Level=start_level+2
    lasth=lasth.Next
    # Generate state "Running.Timer" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="Timer"
    if state_prefix==None:
      lasth.Next.PathName="Running.Timer"
    else:
      lasth.Next.PathName=state_prefix+".Running.Timer"
    lasth.Next.StateNum=10
    lasth.Next.Level=start_level+1
    lasth=lasth.Next
    # Generate state "Running.Timer.IncrementTime" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="IncrementTime"
    if state_prefix==None:
      lasth.Next.PathName="Running.Timer.IncrementTime"
    else:
      lasth.Next.PathName=state_prefix+".Running.Timer.IncrementTime"
    lasth.Next.StateNum=11
    lasth.Next.Level=start_level+2
    lasth=lasth.Next
    # Generate state "Setup" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="Setup"
    if state_prefix==None:
      lasth.Next.PathName="Setup"
    else:
      lasth.Next.PathName=state_prefix+".Setup"
    lasth.Next.StateNum=12
    lasth.Next.Level=start_level+0
    lasth=lasth.Next
    # Generate state "Stopped" in the hierarchy table
    lasth.Next=Hierarchy()
    lasth.Next.StateName="Stopped"
    if state_prefix==None:
      lasth.Next.PathName="Stopped"
    else:
      lasth.Next.PathName=state_prefix+".Stopped"
    lasth.Next.StateNum=13
    lasth.Next.Level=start_level+0
    lasth=lasth.Next
    return h.Next

  def topLevelHistory(self):

    s=self.state.StateID
    t=self.getParentState(s)
    while t!=-1:
      s=t
      t=self.getParentState(s)
    self.changeState(s, s)

  def runActionCode(self, code_num):

    if code_num==0: # model finalizer
      pass
    elif code_num==1: # model initializer
      pass
    elif code_num==2: # output action(s) of a transition
      self.runCode("SSGridView.increaseTimeByOne()")
    elif code_num==3: # output action(s) of a transition
      self.runCode("event=eventhandler.get_event_params()")
      self.runCode("oldCCoord = SSGridView.getSelectedCell()")
      self.runCode("newCCoord = SSGridView.cellCoords(event.x,event.y)")
      self.runCode("curDataLeft=SSGridView.getCellFormula(newCCoord)")
      self.runCode("curDataRight=\"\"")
      self.runCode("SSGridView.drawText(newCCoord,curDataLeft)")
      self.runCode("SSGridView.drawCursor(newCCoord)")
      self.runCode("SSGridView.setOverCellDisplay(curDataLeft)")
      self.runCode("SSGridView.moveSelectedCellTo(newCCoord.col,newCCoord.row)")
    elif code_num==4: # output action(s) of a transition
      self.runCode("event=eventhandler.get_event_params()")
      self.runCode("oldCCoord = SSGridView.getSelectedCell()")
      self.runCode("newCCoord = SSGridView.cellCoords(event.x,event.y)")
      self.runCode("SSGridView.deleteCursor()")
      self.runCode("SSGridView.drawText(oldCCoord,SSGridView.getCellValue(oldCCoord),centered=1)")
      self.runCode("curDataLeft=SSGridView.getCellFormula(newCCoord)")
      self.runCode("curDataRight=\"\"")
      self.runCode("SSGridView.drawText(newCCoord,curDataLeft)")
      self.runCode("SSGridView.drawCursor(newCCoord)")
      self.runCode("SSGridView.setOverCellDisplay(curDataLeft)")
      self.runCode("SSGridView.moveSelectedCellTo(newCCoord.col,newCCoord.row)")
    elif code_num==5: # output action(s) of a transition
      self.runCode("oldCCoord = SSGridView.getSelectedCell()")
      self.runCode("newRow=(oldCCoord.row+1)%SSGridView.getHeight()")
      self.runCode("newCol=0")
      self.runCode("if oldCCoord.row!=SSGridView.getHeight()-1: newCol=oldCCoord.col")
      self.runCode("if oldCCoord.row==SSGridView.getHeight()-1: newCol=(oldCCoord.col+1)%SSGridView.getWidth()")
      self.runCode("SSGridView.moveSelectedCellTo(newCol,newRow)")
    elif code_num==6: # output action(s) of a transition
      self.runCode("oldCCoord = SSGridView.getSelectedCell()")
      self.runCode("newRow=(oldCCoord.row+1)%SSGridView.getHeight()")
      self.runCode("newCol=0")
      self.runCode("if oldCCoord.row!=SSGridView.getHeight()-1: newCol=oldCCoord.col")
      self.runCode("if oldCCoord.row==SSGridView.getHeight()-1: newCol=(oldCCoord.col+1)%SSGridView.getWidth()")
      self.runCode("SSGridView.deleteCursor()")
      self.runCode("SSGridView.drawText(oldCCoord,SSGridView.getCellValue(oldCCoord),centered=1)")
      self.runCode("SSGridView.moveSelectedCellTo(newCol,newRow)")
    elif code_num==7: # output action(s) of a transition
      self.runCode("event=eventhandler.get_event_params()")
      self.runCode("curDataLeft=event.char")
      self.runCode("curDataRight=\"\"")
      self.runCode("SSGridView.drawText(SSGridView.getSelectedCell(),curDataLeft,curDataRight)")
      self.runCode("SSGridView.deleteCursor()")
      self.runCode("SSGridView.drawCursor(SSGridView.getSelectedCell())")
      self.runCode("SSGridView.setOverCellDisplay(curDataLeft+curDataRight)")
    elif code_num==8: # output action(s) of a transition
      self.runCode("event=eventhandler.get_event_params()")
      self.runCode("curDataLeft+=event.char")
      self.runCode("SSGridView.drawText(SSGridView.getSelectedCell(),curDataLeft,curDataRight)")
      self.runCode("SSGridView.deleteCursor()")
      self.runCode("SSGridView.drawCursor(SSGridView.getSelectedCell())")
      self.runCode("SSGridView.setOverCellDisplay(curDataLeft+curDataRight)")
    elif code_num==9: # output action(s) of a transition
      self.runCode("curDataLeft=curDataLeft[0:-1]")
      self.runCode("SSGridView.drawText(SSGridView.getSelectedCell(),curDataLeft,curDataRight)")
      self.runCode("SSGridView.deleteCursor()")
      self.runCode("SSGridView.drawCursor(SSGridView.getSelectedCell())")
      self.runCode("SSGridView.setOverCellDisplay(curDataLeft+curDataRight)")
    elif code_num==10: # output action(s) of a transition
      self.runCode("curDataRight=curDataRight[1:]")
      self.runCode("SSGridView.drawText(SSGridView.getSelectedCell(),curDataLeft,curDataRight)")
      self.runCode("SSGridView.setOverCellDisplay(curDataLeft+curDataRight)")
    elif code_num==11: # output action(s) of a transition
      self.runCode("oldCCoord = SSGridView.getSelectedCell()")
      self.runCode("newCol=(oldCCoord.col-1)%SSGridView.getWidth()")
      self.runCode("newRow=0")
      self.runCode("if oldCCoord.col!=0: newRow=oldCCoord.row")
      self.runCode("if oldCCoord.col==0: newRow=(oldCCoord.row-1)%SSGridView.getHeight()")
      self.runCode("SSGridView.moveSelectedCellTo(newCol,newRow)")
    elif code_num==12: # output action(s) of a transition
      self.runCode("oldCCoord = SSGridView.getSelectedCell()")
      self.runCode("newCol=(oldCCoord.col-1)%SSGridView.getWidth()")
      self.runCode("newRow=0")
      self.runCode("if oldCCoord.col!=0: newRow=oldCCoord.row")
      self.runCode("if oldCCoord.col==0: newRow=(oldCCoord.row-1)%SSGridView.getHeight()")
      self.runCode("SSGridView.deleteCursor()")
      self.runCode("SSGridView.drawText(oldCCoord,SSGridView.getCellValue(oldCCoord),centered=1)")
      self.runCode("SSGridView.moveSelectedCellTo(newCol,newRow)")
    elif code_num==13: # output action(s) of a transition
      self.runCode("oldCCoord = SSGridView.getSelectedCell()")
      self.runCode("curDataRight=curDataLeft[-1]+curDataRight")
      self.runCode("curDataLeft=curDataLeft[:-1]")
      self.runCode("SSGridView.drawText(oldCCoord,curDataLeft,curDataRight)")
      self.runCode("SSGridView.deleteCursor()")
      self.runCode("SSGridView.drawCursor(oldCCoord)")
    elif code_num==14: # output action(s) of a transition
      self.runCode("event=eventhandler.get_event_params()")
      self.runCode("oldCCoord = SSGridView.getSelectedCell()")
      self.runCode("newCCoord = SSGridView.cellCoords(event.x,event.y)")
      self.runCode("SSGridView.moveSelectedCellTo(newCCoord.col,newCCoord.row)")
    elif code_num==15: # output action(s) of a transition
      self.runCode("event=eventhandler.get_event_params()")
      self.runCode("oldCCoord = SSGridView.getSelectedCell()")
      self.runCode("newCCoord = SSGridView.cellCoords(event.x,event.y)")
      self.runCode("curDataLeft=SSGridView.getCellFormula(oldCCoord)")
      self.runCode("curDataRight=\"\"")
      self.runCode("SSGridView.drawText(oldCCoord,curDataLeft)")
      self.runCode("SSGridView.drawCursor(oldCCoord)")
      self.runCode("SSGridView.setOverCellDisplay(curDataLeft)")
    elif code_num==16: # output action(s) of a transition
      self.runCode("event=eventhandler.get_event_params()")
      self.runCode("oldCCoord = SSGridView.getSelectedCell()")
      self.runCode("newCCoord = SSGridView.cellCoords(event.x,event.y)")
      self.runCode("SSGridView.drawText(oldCCoord,SSGridView.getCellValue(oldCCoord),centered=1)")
      self.runCode("SSGridView.deleteCursor()")
      self.runCode("SSGridView.moveSelectedCellTo(newCCoord.col,newCCoord.row)")
      self.runCode("curDataLeft=\"\"")
      self.runCode("curDataRight=\"\"")
    elif code_num==17: # output action(s) of a transition
      self.runCode("event=eventhandler.get_event_params()")
      self.runCode("newCCoord=SSGridView.cellCoords(event.x,event.y)")
      self.runCode("SSGridView.moveOverCellTo(newCCoord.col,newCCoord.row)")
      self.runCode("SSGridView.setColRowDisplay(str(SSGridView.getOverCell()))")
      self.runCode("SSGridView.setOverCellDisplay(SSGridView.getCellFormula(SSGridView.getOverCell()))")
    elif code_num==18: # output action(s) of a transition
      self.runCode("event=eventhandler.get_event_params()")
      self.runCode("newCCoord=SSGridView.cellCoords(event.x,event.y)")
      self.runCode("SSGridView.moveOverCellTo(newCCoord.col,newCCoord.row)")
      self.runCode("SSGridView.setColRowDisplay(str(SSGridView.getOverCell()))")
      self.runCode("SSGridView.setOverCellDisplay(curDataLeft+curDataRight)")
    elif code_num==19: # output action(s) of a transition
      self.runCode("event=eventhandler.get_event_params()")
      self.runCode("newCCoord=SSGridView.cellCoords(event.x,event.y)")
      self.runCode("SSGridView.moveOverCellTo(newCCoord.col,newCCoord.row)")
      self.runCode("SSGridView.setColRowDisplay(str(SSGridView.getOverCell()))")
      self.runCode("SSGridView.setOverCellDisplay(SSGridView.getCellFormula(SSGridView.getOverCell()))")
    elif code_num==20: # output action(s) of a transition
      self.runCode("SSGridView.printView()")
    elif code_num==21: # output action(s) of a transition
      self.runCode("oldCCoord = SSGridView.getSelectedCell()")
      self.runCode("newCol=(oldCCoord.col+1)%SSGridView.getWidth()")
      self.runCode("newRow=0")
      self.runCode("if oldCCoord.col!=SSGridView.getWidth()-1: newRow=oldCCoord.row")
      self.runCode("if oldCCoord.col==SSGridView.getWidth()-1: newRow=(oldCCoord.row+1)%SSGridView.getHeight()")
      self.runCode("SSGridView.moveSelectedCellTo(newCol,newRow)")
    elif code_num==22: # output action(s) of a transition
      self.runCode("oldCCoord = SSGridView.getSelectedCell()")
      self.runCode("newCol=(oldCCoord.col+1)%SSGridView.getWidth()")
      self.runCode("newRow=0")
      self.runCode("if oldCCoord.col!=SSGridView.getWidth()-1: newRow=oldCCoord.row")
      self.runCode("if oldCCoord.col==SSGridView.getWidth()-1: newRow=(oldCCoord.row+1)%SSGridView.getHeight()")
      self.runCode("SSGridView.deleteCursor()")
      self.runCode("SSGridView.drawText(oldCCoord,SSGridView.getCellValue(oldCCoord),centered=1)")
      self.runCode("SSGridView.moveSelectedCellTo(newCol,newRow)")
    elif code_num==23: # output action(s) of a transition
      self.runCode("oldCCoord = SSGridView.getSelectedCell()")
      self.runCode("curDataLeft+=curDataRight[0]")
      self.runCode("curDataRight=curDataRight[1:]")
      self.runCode("SSGridView.drawText(oldCCoord,curDataLeft,curDataRight)")
      self.runCode("SSGridView.deleteCursor()")
      self.runCode("SSGridView.drawCursor(oldCCoord)")
    elif code_num==24: # output action(s) of a transition
      self.runCode("SSGridView=eventhandler.get_event_params()")
    elif code_num==25: # output action(s) of a transition
      self.runCode("oldCCoord = SSGridView.getSelectedCell()")
      self.runCode("newRow=(oldCCoord.row-1)%SSGridView.getHeight()")
      self.runCode("newCol=0")
      self.runCode("if oldCCoord.row!=0: newCol=oldCCoord.col")
      self.runCode("if oldCCoord.row==0: newCol=(oldCCoord.col-1)%SSGridView.getWidth()")
      self.runCode("SSGridView.moveSelectedCellTo(newCol,newRow)")
    elif code_num==26: # output action(s) of a transition
      self.runCode("oldCCoord = SSGridView.getSelectedCell()")
      self.runCode("newRow=(oldCCoord.row-1)%SSGridView.getHeight()")
      self.runCode("newCol=0")
      self.runCode("if oldCCoord.row!=0: newCol=oldCCoord.col")
      self.runCode("if oldCCoord.row==0: newCol=(oldCCoord.col-1)%SSGridView.getWidth()")
      self.runCode("SSGridView.deleteCursor()")
      self.runCode("SSGridView.drawText(oldCCoord,SSGridView.getCellValue(oldCCoord),centered=1)")
      self.runCode("SSGridView.moveSelectedCellTo(newCol,newRow)")
    elif code_num==27: # enter actions for state "Running.Timer.IncrementTime"
      # a timed transition
      sched=Scheduler(self, "__INTERNAL_0_TIME_0", eval("1", self.DefaultInterpreter.locals), 1)
      sched.Next=self.TimedTransitions[11]
      self.TimedTransitions[11]=sched
      sched.start()
    elif code_num==28: # enter actions for state "Stopped"
      # run finalizer for a final state
      self.runFinalizer()
    elif code_num==29: # enter actions for state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
      self.runCode("SSGridView.setTimeWhite()")
      # a timed transition
      sched=Scheduler(self, "__INTERNAL_0_TIME_1", eval("0.5", self.DefaultInterpreter.locals), 1)
      sched.Next=self.TimedTransitions[7]
      self.TimedTransitions[7]=sched
      sched.start()
    elif code_num==30: # enter actions for state "Running.Control.Editing.FlashTime.Flashing.WhiteOnBlack"
      self.runCode("SSGridView.setTimeBlack()")
      # a timed transition
      sched=Scheduler(self, "__INTERNAL_0_TIME_2", eval("0.5", self.DefaultInterpreter.locals), 1)
      sched.Next=self.TimedTransitions[8]
      self.TimedTransitions[8]=sched
      sched.start()
    elif code_num==31: # exit actions for state "Running.Control.Editing.FlashTime.Flashing"
      self.runCode("SSGridView.setTimeWhite()")
    elif code_num==32: # exit actions for state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
      # clean up timed transitions
      if self.TimedTransitions[7]:
        self.TimedTransitions[7].clear()
        self.TimedTransitions[7]=None
    elif code_num==33: # exit actions for state "Running.Control.Editing.FlashTime.Flashing.WhiteOnBlack"
      # clean up timed transitions
      if self.TimedTransitions[8]:
        self.TimedTransitions[8].clear()
        self.TimedTransitions[8]=None
    elif code_num==34: # exit actions for state "Running.Timer.IncrementTime"
      # clean up timed transitions
      if self.TimedTransitions[11]:
        self.TimedTransitions[11].clear()
        self.TimedTransitions[11]=None

  def testCondition(self, cond_num):

    if cond_num==0 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=((SSGridView.getSelectedCell().row!=SSGridView.cellCoords(eventhandler.get_event_params().x,eventhandler.get_event_params().y).row or SSGridView.getSelectedCell().col!=SSGridView.cellCoords(eventhandler.get_event_params().x,eventhandler.get_event_params().y).col) and SSGridView.acceptData(SSGridView.getSelectedCell(),curDataLeft+curDataRight))")==0 and self.TestResult:
      return 1
    elif cond_num==1 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(SSGridView.acceptData(SSGridView.getSelectedCell(),curDataLeft+curDataRight))")==0 and self.TestResult:
      return 1
    elif cond_num==2 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(SSGridView.isDigitChar(eventhandler.get_event_params().keysym) or SSGridView.isPeriod(eventhandler.get_event_params().keysym) or SSGridView.isEquals(eventhandler.get_event_params().keysym) or SSGridView.isAlphaChar(eventhandler.get_event_params().keysym) or SSGridView.isNonAlphaChar(eventhandler.get_event_params().keysym))")==0 and self.TestResult:
      return 1
    elif cond_num==3 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(SSGridView.isDigitChar(eventhandler.get_event_params().keysym) or SSGridView.isPeriod(eventhandler.get_event_params().keysym) or SSGridView.isEquals(eventhandler.get_event_params().keysym) or SSGridView.isAlphaChar(eventhandler.get_event_params().keysym) or SSGridView.isNonAlphaChar(eventhandler.get_event_params().keysym))")==0 and self.TestResult:
      return 1
    elif cond_num==4 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(eventhandler.get_event_params().keysym==\'BackSpace\' and len(curDataLeft)>0)")==0 and self.TestResult:
      return 1
    elif cond_num==5 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(eventhandler.get_event_params().keysym==\'Delete\' and len(curDataRight)>0)")==0 and self.TestResult:
      return 1
    elif cond_num==6 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(len(curDataLeft)==0 and SSGridView.acceptData(SSGridView.getSelectedCell(),curDataLeft+curDataRight))")==0 and self.TestResult:
      return 1
    elif cond_num==7 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(len(curDataLeft)>0)")==0 and self.TestResult:
      return 1
    elif cond_num==8 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(SSGridView.getSelectedCell().row!=SSGridView.cellCoords(eventhandler.get_event_params().x,eventhandler.get_event_params().y).row or SSGridView.getSelectedCell().col!=SSGridView.cellCoords(eventhandler.get_event_params().x,eventhandler.get_event_params().y).col)")==0 and self.TestResult:
      return 1
    elif cond_num==9 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(SSGridView.getSelectedCell().row==SSGridView.cellCoords(eventhandler.get_event_params().x,eventhandler.get_event_params().y).row and SSGridView.getSelectedCell().col==SSGridView.cellCoords(eventhandler.get_event_params().x,eventhandler.get_event_params().y).col)")==0 and self.TestResult:
      return 1
    elif cond_num==10 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(SSGridView.getSelectedCell().row==SSGridView.cellCoords(eventhandler.get_event_params().x,eventhandler.get_event_params().y).row and SSGridView.getSelectedCell().col==SSGridView.cellCoords(eventhandler.get_event_params().x,eventhandler.get_event_params().y).col)")==0 and self.TestResult:
      return 1
    elif cond_num==11 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=((SSGridView.getSelectedCell().row!=SSGridView.cellCoords(eventhandler.get_event_params().x,eventhandler.get_event_params().y).row or SSGridView.getSelectedCell().col!=SSGridView.cellCoords(eventhandler.get_event_params().x,eventhandler.get_event_params().y).col) and SSGridView.acceptData(SSGridView.getSelectedCell(),curDataLeft+curDataRight))")==0 and self.TestResult:
      return 1
    elif cond_num==12 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(SSGridView.getSelectedCell().row==SSGridView.cellCoords(eventhandler.get_event_params().x,eventhandler.get_event_params().y).row and SSGridView.getSelectedCell().col==SSGridView.cellCoords(eventhandler.get_event_params().x,eventhandler.get_event_params().y).col)")==0 and self.TestResult:
      return 1
    elif cond_num==13 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(SSGridView.getSelectedCell().row!=SSGridView.cellCoords(eventhandler.get_event_params().x,eventhandler.get_event_params().y).row or SSGridView.getSelectedCell().col!=SSGridView.cellCoords(eventhandler.get_event_params().x,eventhandler.get_event_params().y).col)")==0 and self.TestResult:
      return 1
    elif cond_num==14 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(len(curDataRight)==0 and) and (SSGridView.acceptData(SSGridView.getSelectedCell(),curDataLeft+curDataRight))")==0 and self.TestResult:
      return 1
    elif cond_num==15 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(len(curDataRight)>0)")==0 and self.TestResult:
      return 1
    elif cond_num==16 and \
       self.DefaultInterpreter.runsource("eventhandler.TestResult=(SSGridView.acceptData(SSGridView.getSelectedCell(),curDataLeft+curDataRight))")==0 and self.TestResult:
      return 1
    return 0

  def runEnterActions(self, state):

    if state==11: # enter action(s) for state "Running.Timer.IncrementTime"
      self.runActionCode(27)
    elif state==13: # enter action(s) for state "Stopped"
      self.runActionCode(28)
    elif state==7: # enter action(s) for state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
      self.runActionCode(29)
    elif state==8: # enter action(s) for state "Running.Control.Editing.FlashTime.Flashing.WhiteOnBlack"
      self.runActionCode(30)

  def runExitActions(self, state):

    if state==6: # exit action(s) for state "Running.Control.Editing.FlashTime.Flashing"
      self.runActionCode(31)
    elif state==7: # exit action(s) for state "Running.Control.Editing.FlashTime.Flashing.BlackOnWhite"
      self.runActionCode(32)
    elif state==8: # exit action(s) for state "Running.Control.Editing.FlashTime.Flashing.WhiteOnBlack"
      self.runActionCode(33)
    elif state==11: # exit action(s) for state "Running.Timer.IncrementTime"
      self.runActionCode(34)

  def recordAllEnteredStates(self):

    st=self.state
    while st!=None:
      self.recordEnteredState(st.StateID, 1, 1)
      st=st.Next

  def recordEnteredState(self, s, superstates=0, submodel=0, commonstate=-1):

    # test if s is already recorded
    se=self.StatesEntered
    found=0
    while se!=None:
      if se.int==s:
        found=1
        break
      se=se.Next

    if not found:
      if superstates:
        parent=self.getParentState(s)
        if parent>=0 and parent!=commonstate:
          self.recordEnteredState(parent, 1)
      st=IntList()
      st.Next=self.StatesEntered
      st.int=s
      self.StatesEntered=st
      if submodel and self.Submodels[s]:
        self.Submodels[s].recordAllEnteredStates()

  def runAllEnterActions(self):

    self.runEnterActionsForStates(self.StatesEntered, 1)

  def runEnterActionsForStates(self, states, recursive=0):

    if states:
      self.runEnterActionsForStates(states.Next, 0)
      self.runEnterActions(states.int)
    if recursive:
      for s in self.Submodels:
        if s:
          s.runAllEnterActions()

  def runExitActionsForStates(self, common_state):

    substates=self.getSubstates(common_state)
    if substates==None:
      s=self.state
      while s!=None and s.StateID!=common_state:
        s=s.Next
      if s!=None and self.Submodels[s.StateID]:
        self.Submodels[s.StateID].runExitActionsForStates(-1)
      return s!=None
    else:
      has_current_substate=0
      while substates!=None:
        res=self.runExitActionsForStates(substates.int)
        has_current_substate=has_current_substate or res
        if res:
          self.runExitActions(substates.int)
        substates=substates.Next
      return has_current_substate

  def runInitializer(self):

    self.runActionCode(1)
    for s in self.Submodels:
      if s:
        s.runInitializer()

  def runFinalizer(self):

    if self.Started:
      for s in self.Submodels:
        if s:
          s.runFinalizer()
      self.runActionCode(0)
      self.Started=0

  def clearEnteredStates(self):

    self.StatesEntered=None
    for s in self.Submodels:
      if s:
        s.clearEnteredStates()

  def runCode(self, c):

    if len(c)>0:
      l=""
      for i in string.split(c, "\n"):
        if len(l)==0:
          l=i
        elif string.find(i, " ")!=0 and not (string.find(i, "else")==0 and string.strip(i[4:])==":") and \
                               string.find(i, "elif ")!=0 and string.find(i, "elif\t")!=0 and \
                               not (string.find(i, "except")==0 and string.strip(i[6:])==":") and \
                               string.find(i, "except ")!=0 and string.find(i, "except\t")!=0:
          self.DefaultInterpreter.runsource(l+"\n")
          l=i
        else:
          l=l+"\n"+i
      if len(l)>0:
        self.DefaultInterpreter.runsource(l+"\n")

  def setupInterpreter(self):

    self.DefaultInterpreter.locals["eventhandler"]=self
    self.DefaultInterpreter.locals["dump_message"]=self.dump_message

  def checkPendingEvents(self):

    self.EventsLock.acquire()
    ev=self.PendingEvents
    if ev!=None:
      self.PendingEvents=ev.Next
      if self.PendingEvents==None:
        self.PendingEventsTail=None
      self.EventsLock.release()
      self.handleEvent(ev.Event[0], ev.Event[1], ev.Event[2], ev.Event[3])
    else:
      self.HandleEventRunning=0
      self.EventsLock.release()

  def get_event_params(self):

    return self.params

  def dump_message(self, msg):

    print msg

  def is_in_state(self, state, check_substate=0):

    i=0
    while i<SSGridViewStateChart.StateNum and SSGridViewStateChart.StateNames[i]!=state:
      i=i+1
    if i<SSGridViewStateChart.StateNum:
      return (not check_substate or self.isLeafState(i)) and self.isInState(i)
    else:
      return 0

  def start(self, lock=None, run_enter_actions=1):

    if run_enter_actions:
      self.runEnterActionsForStates(self.StatesEntered, 1)
    self.Started=1
    if run_enter_actions:
      self.checkPendingEvents()
    if lock:
      lock.release()

  def shutdown(self):

    pass

  def event(self, e, params=[], lock=None, call_submodels=1):

    self.EventsLock.acquire()
    running=self.HandleEventRunning
    if not running and self.Started:
      self.HandleEventRunning=1
    self.EventsLock.release()
    if not running and self.Started:
      thread.start_new_thread(self.handleEvent, (e, params, lock, call_submodels))
    else:
      self.EventsLock.acquire()
      ev=EventList()
      ev.Event=[e, params, lock, call_submodels]
      if self.PendingEventsTail!=None:
        self.PendingEventsTail.Next=ev
      else:
        self.PendingEvents=ev
      self.PendingEventsTail=ev
      self.EventsLock.release()


# main
if __name__=="__main__":
  SSGridViewStateChart().main(sys.argv)